# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import json
import warnings
import pulumi
import pulumi.runtime
from typing import Union
from .. import utilities, tables

class GetPoolsResult:
    """
    A collection of values returned by getPools.
    """
    def __init__(__self__, agent_pools=None, id=None):
        if agent_pools and not isinstance(agent_pools, list):
            raise TypeError("Expected argument 'agent_pools' to be a list")
        __self__.agent_pools = agent_pools
        if id and not isinstance(id, str):
            raise TypeError("Expected argument 'id' to be a str")
        __self__.id = id
        """
        The provider-assigned unique ID for this managed resource.
        """
class AwaitableGetPoolsResult(GetPoolsResult):
    # pylint: disable=using-constant-test
    def __await__(self):
        if False:
            yield self
        return GetPoolsResult(
            agent_pools=self.agent_pools,
            id=self.id)

def get_pools(opts=None):
    """
    Use this data source to access information about existing Agent Pools within Azure DevOps.

    ## Example Usage



    ```python
    import pulumi
    import pulumi_azuredevops as azuredevops

    pools = azuredevops.Agent.get_pools()
    pulumi.export("agentPoolName", [__item["name"] for __item in pools.agent_pools])
    pulumi.export("autoProvision", [__item["auto_provision"] for __item in pools.agent_pools])
    pulumi.export("poolType", [__item["pool_type"] for __item in pools.agent_pools])
    ```

    ## Relevant Links

    - [Azure DevOps Service REST API 5.1 - Agent Pools - Get](https://docs.microsoft.com/en-us/rest/api/azure/devops/distributedtask/pools/get?view=azure-devops-rest-5.1)
    """
    __args__ = dict()


    if opts is None:
        opts = pulumi.InvokeOptions()
    if opts.version is None:
        opts.version = utilities.get_version()
    __ret__ = pulumi.runtime.invoke('azuredevops:Agent/getPools:getPools', __args__, opts=opts).value

    return AwaitableGetPoolsResult(
        agent_pools=__ret__.get('agentPools'),
        id=__ret__.get('id'))
