# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import json
import warnings
import pulumi
import pulumi.runtime
from typing import Union
from .. import utilities, tables

class GitHub(pulumi.CustomResource):
    auth_oauth: pulumi.Output[dict]
    """
    An `auth_oauth` block as documented below. Allows connecting using an Oauth token.

      * `oauthConfigurationId` (`str`)
    """
    auth_personal: pulumi.Output[dict]
    """
    An `auth_personal` block as documented below. Allows connecting using a personal access token.

      * `personalAccessToken` (`str`) - The Personal Access Token for Github.
      * `personalAccessTokenHash` (`str`)
    """
    authorization: pulumi.Output[dict]
    description: pulumi.Output[str]
    project_id: pulumi.Output[str]
    """
    The project ID or project name.
    """
    service_endpoint_name: pulumi.Output[str]
    """
    The Service Endpoint name.
    """
    def __init__(__self__, resource_name, opts=None, auth_oauth=None, auth_personal=None, authorization=None, description=None, project_id=None, service_endpoint_name=None, __props__=None, __name__=None, __opts__=None):
        """
        Manages a GitHub service endpoint within Azure DevOps.

        ## Example Usage



        ```python
        import pulumi
        import pulumi_azuredevops as azuredevops

        project = azuredevops.core.Project("project",
            project_name="Sample Project",
            visibility="private",
            version_control="Git",
            work_item_template="Agile")
        serviceendpoint_gh1 = azuredevops.service_endpoint.GitHub("serviceendpointGh1",
            project_id=project.id,
            service_endpoint_name="Sample GithHub Personal Access Token",
            auth_personal={
                "personalAccessToken": "xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx",
            })
        ```

        ## Relevant Links

        * [Azure DevOps Service REST API 5.1 - Agent Pools](https://docs.microsoft.com/en-us/rest/api/azure/devops/serviceendpoint/endpoints?view=azure-devops-rest-5.1)

        :param str resource_name: The name of the resource.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[dict] auth_oauth: An `auth_oauth` block as documented below. Allows connecting using an Oauth token.
        :param pulumi.Input[dict] auth_personal: An `auth_personal` block as documented below. Allows connecting using a personal access token.
        :param pulumi.Input[str] project_id: The project ID or project name.
        :param pulumi.Input[str] service_endpoint_name: The Service Endpoint name.

        The **auth_oauth** object supports the following:

          * `oauthConfigurationId` (`pulumi.Input[str]`)

        The **auth_personal** object supports the following:

          * `personalAccessToken` (`pulumi.Input[str]`) - The Personal Access Token for Github.
          * `personalAccessTokenHash` (`pulumi.Input[str]`)
        """
        if __name__ is not None:
            warnings.warn("explicit use of __name__ is deprecated", DeprecationWarning)
            resource_name = __name__
        if __opts__ is not None:
            warnings.warn("explicit use of __opts__ is deprecated, use 'opts' instead", DeprecationWarning)
            opts = __opts__
        if opts is None:
            opts = pulumi.ResourceOptions()
        if not isinstance(opts, pulumi.ResourceOptions):
            raise TypeError('Expected resource options to be a ResourceOptions instance')
        if opts.version is None:
            opts.version = utilities.get_version()
        if opts.id is None:
            if __props__ is not None:
                raise TypeError('__props__ is only valid when passed in combination with a valid opts.id to get an existing resource')
            __props__ = dict()

            __props__['auth_oauth'] = auth_oauth
            __props__['auth_personal'] = auth_personal
            __props__['authorization'] = authorization
            __props__['description'] = description
            if project_id is None:
                raise TypeError("Missing required property 'project_id'")
            __props__['project_id'] = project_id
            if service_endpoint_name is None:
                raise TypeError("Missing required property 'service_endpoint_name'")
            __props__['service_endpoint_name'] = service_endpoint_name
        super(GitHub, __self__).__init__(
            'azuredevops:ServiceEndpoint/gitHub:GitHub',
            resource_name,
            __props__,
            opts)

    @staticmethod
    def get(resource_name, id, opts=None, auth_oauth=None, auth_personal=None, authorization=None, description=None, project_id=None, service_endpoint_name=None):
        """
        Get an existing GitHub resource's state with the given name, id, and optional extra
        properties used to qualify the lookup.

        :param str resource_name: The unique name of the resulting resource.
        :param str id: The unique provider ID of the resource to lookup.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[dict] auth_oauth: An `auth_oauth` block as documented below. Allows connecting using an Oauth token.
        :param pulumi.Input[dict] auth_personal: An `auth_personal` block as documented below. Allows connecting using a personal access token.
        :param pulumi.Input[str] project_id: The project ID or project name.
        :param pulumi.Input[str] service_endpoint_name: The Service Endpoint name.

        The **auth_oauth** object supports the following:

          * `oauthConfigurationId` (`pulumi.Input[str]`)

        The **auth_personal** object supports the following:

          * `personalAccessToken` (`pulumi.Input[str]`) - The Personal Access Token for Github.
          * `personalAccessTokenHash` (`pulumi.Input[str]`)
        """
        opts = pulumi.ResourceOptions.merge(opts, pulumi.ResourceOptions(id=id))

        __props__ = dict()

        __props__["auth_oauth"] = auth_oauth
        __props__["auth_personal"] = auth_personal
        __props__["authorization"] = authorization
        __props__["description"] = description
        __props__["project_id"] = project_id
        __props__["service_endpoint_name"] = service_endpoint_name
        return GitHub(resource_name, opts=opts, __props__=__props__)
    def translate_output_property(self, prop):
        return tables._CAMEL_TO_SNAKE_CASE_TABLE.get(prop) or prop

    def translate_input_property(self, prop):
        return tables._SNAKE_TO_CAMEL_CASE_TABLE.get(prop) or prop

